#include "Library.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void makeLibrary()
{
  char line[1000];
  printf("Please enter the number of books: ");
  fgets(line,sizeof(line), stdin);
  sscanf(line, "%d", &numBooks);

  books = malloc(numBooks*sizeof(Book));

  int i;
  for(i = 0; i < numBooks; i++)
  {
    fgets(line,sizeof(line), stdin);

    char * title = strtok(line,",");
    char * lName = strtok(NULL,",");
    char * fName = strtok(NULL,",");
    char * ddNum = strtok(NULL,",");

    books[i].title = malloc((strlen(title)+1)*sizeof(char));
    books[i].authorLastName = malloc(100*sizeof(char));
    books[i].authorFirstName = malloc(100*sizeof(char));

    strcpy(books[i].title, title);
    strcpy(books[i].authorLastName, lName);
    strcpy(books[i].authorFirstName, fName);
    books[i].callNumber = atof(ddNum);
  }
}

void printBooks()
{
  int i = 0;
  for(i = 0; i < numBooks; i++)
  {
    printBook(i);
    printf("\n");
  }
}

void printBook(int i)
{
  printf("Title:    %s\n", books[i].title);
  printf("Author:   %s, %s\n", books[i].authorLastName, books[i].authorFirstName);
  printf("Dewey Decimal Number:    %lf\n", books[i].callNumber);
}

void destroyLibrary()
{
  int i = 0;
  for(i = 0; i < numBooks; i++)
  {
    free((void *)books[i].title);
    free((void *)books[i].authorLastName);
    free((void *)books[i].authorFirstName);
  }
  free((void *)books);
}

void sortByTitle()
{
  int i;
  for(i = 0; i < numBooks-1; i++)
  {
    int swapLoc = i, j;
    for(j = i; j < numBooks; j++)
    {
      if(strcmp(books[swapLoc].title, books[j].title) > 0)
        swapLoc = j;
    }
    if(swapLoc != i)
      swapBooks(i,swapLoc);
  }
}

void swapBooks(int i,int j)
{
  Book b = books[i];
  books[i] = books[j];
  books[j] = b;
}

void sortByAuthor()
{
  int i;
  for(i = 0; i < numBooks-1; i++)
  {
    int swapLoc = i, j;
    for(j = i; j < numBooks; j++)
    {
      if(strcmp(books[swapLoc].authorLastName, books[j].authorLastName) > 0)
        swapLoc = j;
      else if(strcmp(books[swapLoc].authorLastName, books[j].authorLastName) == 0 &&
        strcmp(books[swapLoc].authorFirstName,books[j].authorFirstName) > 0)
        swapLoc = j;
    }
    if(swapLoc != i)
      swapBooks(i,swapLoc);
  }

}

void sortByCallNumber()
{
  int i;
  for(i = 0; i < numBooks-1; i++)
  {
    int swapLoc = i, j;
    for(j = i; j < numBooks; j++)
    {
      if(books[swapLoc].callNumber > books[j].callNumber)
        swapLoc = j;
    }
    if(swapLoc != i)
      swapBooks(i,swapLoc);
  }
}
